Ptex: Res Struct Reference

Ptex

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Public Attributes | List of all members
Res Struct Reference

Pixel resolution of a given texture. More...

`#include <Ptexture.h>`

## Public Member Functions
| Res ()
| Default constructor, sets res to 0 (1x1 texel). More...
| Res (int8_t ulog2_, int8_t vlog2_)
| Constructor. More...
| Res (uint16_t value)
| Constructor from 16-bit integer. More...
int | u () const
| U resolution in texels. More...
int | v () const
| V resolution in texels. More...
uint16_t & | val ()
| Resolution as a single 16-bit integer value. More...
const uint16_t & | val () const
| Resolution as a single 16-bit integer value. More...
int | size () const
| Total size of specified texture in texels (u * v). More...
bool | operator== (const Res &r) const
| Comparison operator. More...
bool | operator!= (const Res &r) const
| Comparison operator. More...
bool | operator>= (const Res &r) const
| True if res is >= given res in both u and v directions. More...
Res | swappeduv () const
| Get value of resolution with u and v swapped. More...
void | swapuv ()
| Swap the u and v resolution values in place. More...
void | clamp (const Res &r)
| Clamp the resolution value against the given value. More...
int | ntilesu (Res tileres) const
| Determine the number of tiles in the u direction for the given tile res. More...
int | ntilesv (Res tileres) const
| Determine the number of tiles in the v direction for the given tile res. More...
int | ntiles (Res tileres) const
| Determine the total number of tiles for the given tile res. More...

## Public Attributes
int8_t | ulog2
| log base 2 of u resolution, in texels More...
int8_t | vlog2
| log base 2 of v resolution, in texels More...

## Detailed Description

Pixel resolution of a given texture.

The resolution is stored in log form: ulog2 = log2(ures), vlog2 = log2(vres)). Note: negative ulog2 or vlog2 values are reserved for internal use.

Definition at line 274 of file Ptexture.h.

## Constructor & Destructor Documentation

Res::Res | ( |  | ) |
| inline

Default constructor, sets res to 0 (1x1 texel).

Definition at line 279 of file Ptexture.h.

References Ptex::FaceInfo::flag_subface.

Res::Res | ( | int8_t | ulog2_,
|  | int8_t | vlog2_
| ) |  |
| inline

Constructor.

Definition at line 282 of file Ptexture.h.

Res::Res | ( | uint16_t | value | ) |
| inline

Constructor from 16-bit integer.

Definition at line 285 of file Ptexture.h.

## Member Function Documentation

void Res::clamp | ( | const Res & | r | ) |
| inline

Clamp the resolution value against the given value.

Definition at line 321 of file Ptexture.h.

int Res::ntiles | ( | Res | tileres | ) | const
| inline

Determine the total number of tiles for the given tile res.

Definition at line 333 of file Ptexture.h.

int Res::ntilesu | ( | Res | tileres | ) | const
| inline

Determine the number of tiles in the u direction for the given tile res.

Definition at line 327 of file Ptexture.h.

int Res::ntilesv | ( | Res | tileres | ) | const
| inline

Determine the number of tiles in the v direction for the given tile res.

Definition at line 330 of file Ptexture.h.

bool Res::operator!= | ( | const Res & | r | ) | const
| inline

Comparison operator.

Definition at line 309 of file Ptexture.h.

bool Res::operator== | ( | const Res & | r | ) | const
| inline

Comparison operator.

Definition at line 306 of file Ptexture.h.

bool Res::operator>= | ( | const Res & | r | ) | const
| inline

True if res is >= given res in both u and v directions.

Definition at line 312 of file Ptexture.h.

References Ptex::String::_str.

int Res::size | ( |  | ) | const
| inline

Total size of specified texture in texels (u * v).

Definition at line 303 of file Ptexture.h.

Res Res::swappeduv | ( |  | ) | const
| inline

Get value of resolution with u and v swapped.

Definition at line 315 of file Ptexture.h.

void Res::swapuv | ( |  | ) |
| inline

Swap the u and v resolution values in place.

Definition at line 318 of file Ptexture.h.

int Res::u | ( |  | ) | const
| inline

U resolution in texels.

Definition at line 291 of file Ptexture.h.

int Res::v | ( |  | ) | const
| inline

V resolution in texels.

Definition at line 294 of file Ptexture.h.

uint16_t& Res::val | ( |  | ) |
| inline

Resolution as a single 16-bit integer value.

Definition at line 297 of file Ptexture.h.

const uint16_t& Res::val | ( |  | ) | const
| inline

Resolution as a single 16-bit integer value.

Definition at line 300 of file Ptexture.h.

## Member Data Documentation

int8_t Res::ulog2

log base 2 of u resolution, in texels

Definition at line 275 of file Ptexture.h.

Referenced by PtexReader::ReductionKey::Hasher::operator()().

int8_t Res::vlog2

log base 2 of v resolution, in texels

Definition at line 276 of file Ptexture.h.

Referenced by PtexReader::ReductionKey::Hasher::operator()().

The documentation for this struct was generated from the following file:

- Ptexture.h